/*
 *	main.c
 *
 *	܂邿
 *
 *	* Tue Jun 1 21:26:00 JST 2004 Naoyuki Sawa
 *	- 1st [XB
 */
#include "app.h"

/****************************************************************************
 *	
 ****************************************************************************/

#ifdef USE_MUSIC
#include "instdef2.c"
#endif /*USE_MUSIC*/

#ifdef USE_SPRITE
#define SPRITE_ SPRITE_INIT2
const SPRITE sprite_table[SPRITE_COUNT] = {
#include "sprite.h"
};
#undef SPRITE_
#endif /*USE_SPRITE*/

#define extern
#include "work.h"
#undef extern

/****************************************************************************
 *	main
 ****************************************************************************/

int
main()
{
	/* B */
	app_init();

	/* C[vB */
	for(;;) {
		if(demo_main() < 0) break;
		game_main();
	}

	return 0;
}

/****************************************************************************
 *	app_init
 ****************************************************************************/

void
app_init()
{
	/* ʓIȏB */
	pceLCDDispStop();
#ifdef V_SCREEN
	pceLCDSetBuffer(_def_vbuff);
#else /*V_SCREEN*/
	pceLCDSetBuffer(vbuff);
#endif /*V_SCREEN*/
	pceAppSetProcPeriod(1000 / FPS);
	pcePadSetTrigMode(PP_MODE_SINGLE);
	pceLCDDispStart();

	/* `B */
	surface.w = DISP_X;
	surface.h = DISP_Y;
	surface.vbuff = vbuff;
	render_init_2d(&render, &surface, 0, 0, 0, 0);

#if defined(TRACE_ON) && (TRACE_ON)
	/* WG[o͂J܂B */
	stderr_open(1/*WG[o̓j^ڑ҂()*/);
#endif /*TRACE_ON*/

#ifdef USE_MUSIC
	/* yCu܂B */
	music_loudness(1);
	loadInst(); /* uRandomism Zone(http://www8.plala.or.jp/randomism/)v́whFLbgver.2.10xgp */
	InitMusic();
#endif /*USE_MUSIC*/

	/* N[Abv֐o^B */
	atexit(app_exit);

	/* eNX`܂B */
#ifdef TEXTURE_LIST
	{
		typedef const unsigned char TEXTURE_DATA[];
		extern TEXTURE_DATA TEXTURE_LIST;
		texture_table_init(texture_table, sizeof texture_table / sizeof *texture_table, TEXTURE_LIST);
	}
#endif /*TEXTURE_LIST*/

#ifdef USE_SPRITE
	/* ȈՃXvCghCo܂B */
	sprite_init(&render, sprite_table, SPRITE_COUNT, texture_table, TEXTURE_COUNT);
#endif /*USE_SPRITE*/

/*{{AvP[VL̏*/
	//turbo(1); /* S48MHz[h */
	turbo(7); /* 48MHz/1WAIT */
	srand(pceTimerGetCount());

	/* }EX܂B */
	if(mouse_open() < 0) {
		die("}EXs");
	}
/*}}AvP[VL̏*/
}

/****************************************************************************
 *	app_exit
 ****************************************************************************/

void
app_exit()
{
	/* }EXJ܂B */
	mouse_close();

#ifdef USE_MUSIC
	/* mɉyt~܂B
	 * TEh̒~̓CupceAppExit()ōsĂ̂ŁA
	 * ł͕Kv܂B
	 */
	StopMusic();
	music_loudness(0);
#endif /*USE_MUSIC*/
}

/****************************************************************************
 *	schedule
 ****************************************************************************/

void
schedule()
{
#define PAUSE_FONT	0x80		/* PAUSEtHg         */
#define PAUSE_COLOR	0x130		/* PAUSEJ[(wip) */
//#define PAUSE_COLOR	0x203		/* PAUSEJ[(wip) */
#define PAUSE_STR	"PAUSE"		/* PAUSEbZ[W       */
#define PAUSE_W		(5 * 5 + 2)	/* PAUSEbZ[W̉ */
#define PAUSE_H		(10    + 2)	/* PAUSEbZ[W̏c */
#define PAUSE_X		((DISP_X - PAUSE_W) / 2) /* \ʒu */
#define PAUSE_Y		((DISP_Y - PAUSE_H) / 2) /* \ʒu */

#ifdef QUICK_REPEAT
	static unsigned char rep[8]; /* I[gs[gJE^ */
#endif /*QUICK_REPEAT*/

	int pause, x, y;
	/* PAUSEbZ[Ẅ̃C[Wޔpobt@́A324oCgKvłB
	 * X^bNɎ̂͊댯łAstaticɎ̖̂ʂłB
	 * ŁAPAUSEɂ̂݃q[vmۂ邱Ƃɂ܂B
	 */
	//unsigned char save[PAUSE_H][PAUSE_W];
	unsigned char (*save)[PAUSE_W] = NULL/*x}*/;

	pause = 0;
	for(;;) {
#ifdef V_SCREEN
		{ /* vbuff(c)_def_vbuff()ϊ */
			unsigned char *dst, *src;
			dst = &_def_vbuff[0];     /* ]̉ʂ͍ォ瑖Jn܂ */
			src = &vbuff[DISP_X - 1]; /* ]̏cʂ͉Eォ瑖Jn܂ */
			for(x = DISP_X - 1; x >= 0; x--) {
				for(y = 0; y < DISP_Y; y++) {
					*dst = *src;
					dst += 1;      /* ʂEɑ܂ */
					src += DISP_X; /* cʂɑ܂ */
				}
				                            /* ʂ͊Ɏ̍sֈړĂ܂ */
				src -= DISP_X * DISP_Y + 1; /* cʂ̗̈ԏֈړ܂ */
			}
		}
#endif /*V_SCREEN*/
		pceLCDTrans();		/* ʍXV */
		yield();		/* VXe */
		joy = pcePadGet();	/* pbhԍXV */
#ifdef V_SCREEN
		joy = (joy & ~(PAD_LF | PAD_RI | PAD_UP | PAD_DN | /* cʗp͕ϊ */
			       TRG_LF | TRG_RI | TRG_UP | TRG_DN))
			| (joy & PAD_LF ? PAD_UP : 0)
			| (joy & PAD_RI ? PAD_DN : 0)
			| (joy & PAD_UP ? PAD_RI : 0)
			| (joy & PAD_DN ? PAD_LF : 0)
			| (joy & TRG_LF ? TRG_UP : 0)
			| (joy & TRG_RI ? TRG_DN : 0)
			| (joy & TRG_UP ? TRG_RI : 0)
			| (joy & TRG_DN ? TRG_LF : 0);
#endif /*V_SCREEN*/

		/* PAUSEB */
		if(joy & TRG_START) {
			pause = !pause;	/* PAUSEԐ؂ւ */
			if(pause) {	/* PAUSE IN */
				/* PAUSEbZ[W\̃C[WޔB */
				save = (unsigned char (*)[PAUSE_W])malloc(PAUSE_W * PAUSE_H); /* C[Wޔpobt@m */
				if(save == NULL) DIE();
				for(y = 0; y < PAUSE_H; y++) {
					for(x = 0; x < PAUSE_W; x++) {
						save[y][x] = vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)];
					}
				}
			} else {	/* PAUSE OUT */
				/* PAUSEbZ[W\̃C[W𕜋AB */
				for(y = 0; y < PAUSE_H; y++) {
					for(x = 0; x < PAUSE_W; x++) {
						vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)] = save[y][x];
					}
				}
				free(save); /* C[Wޔpobt@J */
			}
		}
		if(!pause) break;

		/* PAUSEbZ[W_ŕ\B */
		if(pceTimerGetCount() % 1000 < 750) {
			render_string_framed(&render, PAUSE_X, PAUSE_Y, PAUSE_STR, PAUSE_FONT, PAUSE_COLOR);
		} else {
			for(y = 0; y < PAUSE_H; y++) {
				for(x = 0; x < PAUSE_W; x++) {
					vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)] = save[y][x];
				}
			}
		}
	}
	now++;	/* O[o^C}XV */

#ifdef QUICK_REPEAT
	/* I[gs[gB */
	for(x = 0; x < 8; x++) {
		y = 1 << x; /* PAD_* */
		if(QUICK_REPEAT_PADS & y) {
			if(joy & y) {
				if(rep[x] != 0xff) rep[x]++;
				if(rep[x] >= QUICK_REPEAT_DELAY) joy |= y << 8; /* TRG_* */
			} else {
				rep[x] = 0;
			}
		}
	}
#endif QUICK_REPEAT

#undef PAUSE_FONT
#undef PAUSE_COLOR
#undef PAUSE_STR
#undef PAUSE_W
#undef PAUSE_H
#undef PAUSE_X
#undef PAUSE_Y

	/* }EXB */
	{
		int dx;
		int dy;
		mouse_get(&dx, &dy, &mouse_button);
		mouse_x += dx;
		mouse_y += dy;
		if(mouse_x < mouse_x_min) mouse_x = mouse_x_min;
		if(mouse_y < mouse_y_min) mouse_y = mouse_y_min;
		if(mouse_x > mouse_x_max) mouse_x = mouse_x_max;
		if(mouse_y > mouse_y_max) mouse_y = mouse_y_max;
	}
}

/****************************************************************************
 *	demo_main
 ****************************************************************************/

int
demo_main()
{
	const char* msg;
	int len;
	int x;
	int y;
	int color;
	int sel;

	/* J[\ړ͈͂ݒB */
	mouse_x_min = 0;
	mouse_x_max = DISP_X - 1;
	mouse_y_min = 0;
	mouse_y_max = DISP_Y - 1;

	for(;;) {
		schedule();
		memset(vbuff, 3, sizeof vbuff);

		/* ^Cg\B */
		msg = "܂邿";
		len = strlen(msg);
		x = (DISP_X - 5 * len) / 2 - 1;
		y = 10 * 2;
		render_string_framed(&render, x, y, msg, 0x80, 0x203);

		sel = 0; /* ܂AJ[\STARTorEXITɂȂƂɂĂ */
		y = 45;

		/* START\B */
		msg = "START";
		len = strlen(msg);
		x = (DISP_X - 5 * len) / 2 - 1;
		if(mouse_x >= x && mouse_x <= x + 5 * len - 1 &&
		   mouse_y >= y && mouse_y <= y + 10 - 1) {
			color = 0x203;
			sel = 1; /* J[\STARTɂ邱Ƃ}[N */
		} else {
			color = 0x223;
		}
		render_string_framed(&render, x, y, msg, 0x80, color);

		y += 15;

		/* EXIT\B */
		msg = "EXIT";
		len = strlen(msg);
		x = (DISP_X - 5 * len) / 2 - 1;
		if(mouse_x >= x && mouse_x <= x + 5 * len - 1 &&
		   mouse_y >= y && mouse_y <= y + 10 - 1) {
			color = 0x203;
			sel = -1; /* J[\EXITɂ邱Ƃ}[N */
		} else {
			color = 0x223;
		}
		render_string_framed(&render, x, y, msg, 0x80, color);

		/* J[\\B */
		sprite_draw(mouse_x, mouse_y, CURSOR, 0);

		/* XRA\B */
		score_disp();

		/* START܂EXITō{^ꂽA܂B */
		if(mouse_button & MOUSE_PRESS(0)) {
			if(sel) break;
		}
	}
	sound_play(1, SND_START);

	return sel;
}

/****************************************************************************
 *	game_main
 ****************************************************************************/

void
game_main()
{
	int i;
	int x;
	int y;
	int len;
	const char* msg;

	/* n}[ړ͈͂ݒB */
	mouse_x_min = HAMMER_X_MIN;
	mouse_x_max = HAMMER_X_MAX;
	mouse_y_min = HAMMER_Y_MIN;
	mouse_y_max = HAMMER_Y_MAX;

	/* Q[B */
	game_init();

	for(;;) {
		schedule();
		memset(vbuff, 3, sizeof vbuff);

		/* }`ANVB */
		mole_action_all();

		/* n}[ANVB */
		hammer_action();

		/* }`oB */
		game.next--;
		if(game.next <= 0) {
			mole_gen();
			game.next = (SEC(1) << 15) / game.speed;
		}

		/* }``B */
		mole_disp_all();

		/* n}[`B */
		hammer_disp();

		/* c莞ԁEXRA`B */
		timer_disp();
		score_disp();

		/* c莞Ԃ炵āA0ɂȂ甲܂B */
		game.timer--;
		if(game.timer <= 0) {
			game.timer = 0;
			break;
		}
	}

	for(i = 0; i < SEC(1 + 3); i++) {
		schedule();
		memset(vbuff, 3, sizeof vbuff);

		/* }`Ec莞ԁEXRA`Bn}[͔\B */
		mole_disp_all();
		timer_disp();
		score_disp();

		/* GAME OVER\B */
		if(i >= SEC(1)) {
			msg = "GAME OVER";
			len = strlen(msg);
			x = (DISP_X - 5 * len) / 2 - 1;
			y = (DISP_Y - 5 *   1) / 2 - 1;
			render_string_framed(&render, x, y, msg, 0x80, 0x203);
		}
	}
}

/****************************************************************************
 *	game_init
 ****************************************************************************/

void
game_init()
{
	/* ܂NAB */
	memset(&game, 0, sizeof game);

	/* V[hB */
	game.seed = pceTimerGetCount();

	/* c莞ԐݒB */
	game.timer = SEC(60/**/);

	/* }`Xs[hB */
	game.speed = 1 << 15;

	/* ŏ̃}`o܂ł̎c莞ԏB */
	game.next = (SEC(1) << 15) / game.speed;
}

/****************************************************************************
 *	mole_gen
 ****************************************************************************/

void
mole_gen()
{
	int i;
	MOLE* mole;

	for(i = 0; i < MAX_MOLE; i++) {
		mole = &game.mole[i];
		if(!mole->state) { /* 󂫃Gg */
			memset(mole, 0, sizeof(MOLE));
			mole->state = MOLE_STATE_LIVE;
			mole->x = RND16(game.seed) % (MOLE_X_MAX - MOLE_X_MIN) + MOLE_X_MIN;
			mole->y = RND16(game.seed) % (MOLE_Y_MAX - MOLE_Y_MIN) + MOLE_Y_MIN;
			break;
		}
	}
}

/****************************************************************************
 *	mole_disp_all
 ****************************************************************************/

static int
mole_compare(const void* _a, const void* _b)
{
	MOLE* a = (MOLE*)_a;
	MOLE* b = (MOLE*)_b;
	return a->y - b->y;
}

void
mole_disp_all()
{
	int i;
	MOLE* mole;

	qsort(game.mole, MAX_MOLE, sizeof(MOLE), mole_compare);

	for(i = 0; i < MAX_MOLE; i++) {
		mole = &game.mole[i];
		if(!mole->state) continue;

		mole_disp(mole);
	}
}

/****************************************************************************
 *	mole_disp
 ****************************************************************************/

void
mole_disp(MOLE* mole)
{
	int count;
	int sprno;

	switch(mole->state) {
	case MOLE_STATE_LIVE:
		sprno = now & 4 ? MULTI0_00 : MULTI1_00;
		count = mole->count >> 16;
		if(count < 0) {
			return;
		} else if(count < 32) {
			count = 31 - count;
		} else if(count < 64) {
			count = count - 32;
		} else {
			return;
		}
		sprno += count;
		sprite_draw(mole->x, mole->y, sprno, 0);
		break;

	case MOLE_STATE_DEAD:
		if(now & 2) return;
		sprno = MULTI2;
		sprite_draw(mole->x, mole->y, sprno, 0);
		break;
	}
}

/****************************************************************************
 *	mole_action_all
 ****************************************************************************/

void
mole_action_all()
{
	int i;
	MOLE* mole;

	for(i = 0; i < MAX_MOLE; i++) {
		mole = &game.mole[i];
		if(!mole->state) continue;

		mole_action(mole);
	}
}

/****************************************************************************
 *	mole_action
 ****************************************************************************/

void
mole_action(MOLE* mole)
{
	switch(mole->state) {
	case MOLE_STATE_LIVE:
		mole->count += game.speed;
		if(mole->count >= 64 << 16) {
			memset(mole, 0, sizeof(MOLE));
		}
		break;

	case MOLE_STATE_DEAD:
		mole->count++;
		if(mole->count >= SEC(1.0/**/)) {
			memset(mole, 0, sizeof(MOLE));
		}
		break;
	}
}


/****************************************************************************
 *	hammer_action
 ****************************************************************************/

void
hammer_action()
{
	int i;
	int hx1;
	int hy1;
	int hx2;
	int hy2;
	int mx1;
	int my1;
	int mx2;
	int my2;
	int count;
	MOLE* mole;
	//
	int hit = 0;

	/* }EX{^ꂽc */
	if(mouse_button & MOUSE_PRESS(0)) {
		/* n}[̓蔻`߂܂B */
		hx1 = mouse_x + HAMMER_HIT_CX - HAMMER_HIT_W / 2;
		hx2 = hx1 + HAMMER_HIT_W;
		hy1 = mouse_y + HAMMER_HIT_CY - HAMMER_HIT_H / 2;
		hy2 = hy1 + HAMMER_HIT_H;

		for(i = 0; i < MAX_MOLE; i++) {
			mole = &game.mole[i];
			if(mole->state != MOLE_STATE_LIVE) continue;

			/* }`̓蔻`߂܂B */
			mx1 = mole->x - MOLE_HIT_W / 2;
			mx2 = mx1 + MOLE_HIT_W;
			my2 = mole->y;
			count = mole->count >> 16;
			if(count < 0) {
				continue;
			} else if(count < 32) {
				count =  1 + count;
			} else if(count < 64) {
				count = 64 - count;
			} else {
				continue;
			}
			my1 = my2 - count;

			/* 蔻B */
			if(hx2 < mx1) continue;
			if(hx1 > mx2) continue;
			if(hy2 < my1) continue;
			if(hy1 > my2) continue;

			/* }`ԕύXB */
			mole->state = MOLE_STATE_DEAD;
			mole->count = 0;

			/* XRAZB */
			game.score += 1;
			if(game.score > hiscore) hiscore = game.score;

			/* }`Xs[hAbvB */
			game.speed = game.speed * 0x104 >> 8;

			hit = 1;
		}

		sound_play(1, SND_START);
		if(hit) sound_play(2, SND_CHORD);
	}
}

/****************************************************************************
 *	hammer_disp
 ****************************************************************************/

void
hammer_disp()
{
	int sprno;

	if(mouse_button & MOUSE_BUTTON(0)) {
		sprno = HAMMER1;
	} else {
		sprno = HAMMER0;
	}
	sprite_draw(mouse_x, mouse_y, sprno, 0);
}

/****************************************************************************
 *	timer_disp
 ****************************************************************************/

void
timer_disp()
{
	int x;
	int y;
	int len;
	char buf[32];

	/* c莞ԕ\B */
	sprintf(buf, "c%02db", (game.timer + (FPS - 1)) / FPS);
	len = strlen(buf);
	x = (DISP_X - 5 * len) / 2 - 1;
	y = 0;
	render_string_framed(&render, x, y, buf, 0x80, 0x203);
}

/****************************************************************************
 *	score_disp
 ****************************************************************************/

void
score_disp()
{
	int x;
	int y;
	int len;
	char buf[32];

	y = 4;

	/* XRA\B */
	sprintf(buf, "1P:%03d", game.score);
	len = strlen(buf);
	x = 0;
	render_string_framed(&render, x, y, buf, 0x82, 0x203);

	/* nCXRA\B */
	sprintf(buf, "HI:%03d", hiscore);
	len = strlen(buf);
	x = DISP_X - 4 * len - 1;
	render_string_framed(&render, x, y, buf, 0x82, 0x203);
}

